package mc600.boardgames;

/**
 * Insert the type's description here.
 * Creation date: (3/24/00 8:24:08 PM)
 * @author: 
 */
class StickSquare {

	/**
	 *  arestas do quadrado
	 *
	 *         a 
	 *     o-------o
	 *     |       |
	 *   d |       | b
	 *     |       |
	 *     o-------o
	 *         c
	 */
	
	private boolean a = false;
	private boolean b = false;
	private boolean c = false;
	private boolean d = false;	

	
	private boolean lastplayer;
/**
 * StickSquare constructor comment.
 */
public StickSquare() {
	super();
}
/**
 * Conecta aresta especificada. Associando quadrado a jogador.
 *
 * Levanta excessao caso a aresta esteja ocupada.
 * Retorna boolean indicando se quadrado foi fechado.
 *
 * Creation date: (3/24/00 8:53:26 PM)
 * @return boolean
 * @param edge char
 */
public boolean connect(boolean isp1, char edge) throws InvalidCastException{
	
	boolean castok=false;

	
	switch (edge){
	case 'a':
	case 'A':
		castok = !a;
		a=true;
		break;
	case 'b':
	case 'B':
		castok = !b;
		b=true;
		break;
	case 'c':
	case 'C':
		castok = !c;
		c=true;
		break;
	case 'd':
	case 'D':
		castok = !d;
		d=true;
		break;
	default:
		castok = false;

	}

	// so altera o "dono" do ultimo lance caso o lance tenha sido valido
	if (castok)
		setLastplayer(isp1);
	else
		throw new InvalidCastException("StickSquare: aresta ocupada.");
		
	return (isFull());
}
/**
 * Insert the method's description here.
 * Creation date: (4/23/00 8:38:16 PM)
 * @return int
 */
protected int count() {
	return ( (a?1:0) + (b?1:0) + (c?1:0) + (d?1:0));
}
/**
 * Conecta aresta especificada. Associando quadrado a jogador.
 *
 * Levanta excessao caso a aresta esteja ocupada.
 * Retorna boolean indicando se quadrado foi fechado.
 *
 * Creation date: (3/24/00 8:53:26 PM)
 * @return boolean
 * @param edge char
 */
public boolean disconnect(char edge) throws InvalidCastException{
	
	boolean castok=false;
	boolean tinhafechado = false;



	tinhafechado = isFull();

	
	switch (edge){
	case 'a':
	case 'A':
		castok = a;
		a=false;
		break;
	case 'b':
	case 'B':
		castok = b;
		b=false;
		break;
	case 'c':
	case 'C':
		castok = c;
		c=false;
		break;
	case 'd':
	case 'D':
		castok = d;
		d=false;
		break;
	default:
		castok = false;

	}


	if (!castok)
		throw new InvalidCastException("StickSquare: aresta ocupada.");
		
	return (tinhafechado);
}
/**
 * Insert the method's description here.
 * Creation date: (4/23/00 9:04:07 PM)
 * @return char
 */
public char getFirstFreeEdge() {


	if (!a)
		return ('a');
	else if (!b)
		return ('b');
	else if (!c)
		return ('c');
	else if (!d)
		return ('d');

	return ('0');			
}
/**
 * Insert the method's description here.
 * Creation date: (3/24/00 9:21:20 PM)
 * @return boolean
 */
public boolean getLastplayer() {
	return lastplayer;
}
/**
 * Verifica se aresta esta conectada.
 *
 * Levanta excessao caso a aresta esteja ocupada.
 * Retorna boolean indicando se quadrado foi fechado.
 *
 * Creation date: (3/24/00 8:53:26 PM)
 * @return boolean
 * @param edge char
 */
public boolean isconnected(char edge) {
	
	boolean connected=false;
	
	switch (edge){
	case 'a':
	case 'A':
	
		connected = a;
		break;
	case 'b':
	case 'B':
		connected = b;
		break;
	case 'c':
	case 'C':
		connected = c;
		break;
	case 'd':
	case 'D':
		connected = d;		
		break;
		
	default:
		connected = false;

	}

		
	return (connected);
}
/**
 * Verifica se todas as arestas estao conectadas, se estivem volta true, caso contrario, false.
 * Creation date: (3/24/00 8:46:27 PM)
 * @return boolean
 */
public boolean isFull() {
	return (a && b && c && d);
}
/**
 * Insert the method's description here.
 * Creation date: (3/24/00 9:21:20 PM)
 * @param newLastplayer boolean
 */
private void setLastplayer(boolean isP1) {
	lastplayer = isP1;
}
}
