package mc600.gamemanager;

import java.text.*;
import java.util.Date;
import java.io.*;
import java.net.*;
/**
 * Insert the type's description here.
 * Creation date: (3/8/00 9:43:20 PM)
 * @author:  
 */
public class Administrator {
	private final static int PERIODICIDADE = 60000; // tempo de espera entre campeonatos, milisegundos 
/**
 * Classe principal, responsavel pela organizacao do "campeonato"
 * Dispara varias threads do objeto Juiz, fazendo com que todos os
 * jogadores joguem entre si.
 *
 * Os jogadores devem estar conectados a uma porta TCP, dentro da faixa
 * determinada pelo objeto "Player", antes do inicio do campeonato.
 *
 * Ao final do campeonato gera um html com a classificacao dos jogadores.
 *
 */
public Administrator() {
	super();
}
/**
 * Metodo grava html com hanking dos participantes.
 *
 * Creation date: (3/26/00 8:58:55 PM)
 * @param players mc600.gamemanager.PlayerQueue[]
 */
private static void gravaHtml(PlayerQueue players, String arq_out) {

	
	PlayerClient p;
	
	RandomAccessFile arq;

 	SimpleDateFormat formatter = new SimpleDateFormat ("dd/MM/yyyy HH:mm:ss");
	Date currentTime = new Date();
	
	String dateString = formatter.format(currentTime);
	String nextChamp  = formatter.format(new Date(System.currentTimeMillis() + PERIODICIDADE));

	// santo codigo porco, batman!!
	String html_top =new String("<html>\n" +
								"<head>\n" +
								"<title>Untitled Document</title>\n" +
								"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\n" +
								"</head>\n\n" + 

								"<body bgcolor=\"#FFFFFF\">\n" + 
								"<p><font size=\"5\" face=\"Arial, Helvetica, sans-serif\">EC98 Apresenta: Jogo dos \n" + 
								" Palitos <br>\n"+ 
								" </font></p>\n" +
								"<hr>\n" + 
								"<p>Data e hora do campeonato mais recente: " + dateString + "<br>\n" + 
								"   Data e hora do pr&oacute;ximo campeonato: " + nextChamp + "</p>\n");

	String html_tableheader = new String("<table width=\"75%\" border=\"1\">\n" +
										 "<tr>\n" +
									     "<td width=\"27%\">N&uacute;mero de Vit&oacute;rias</td>\n" +
										 "<td width=\"73%\">Nome do jogador</td>\n" +
										 "</tr>\n");

	
	String html_bottom = new String("</table>\n" +
									"<p>&nbsp;</p>\n" +
									"<p><a href=\".\">Ser&aacute; que seu jogador est&aacute; com problemas? \n" +
									"  Veja aqui os logs dos jogadores.</a></p>\n"  +
									"<p><a href=\"mc600.zip\">C&oacute;digo fonte do sistema</a></p>\n" +
									"</body>\n" +
									"</html>\n");


		
	// Abre o arquivo arq_out

	try {

	
		System.out.println("Criando arquivo com classificacao: " + arq_out);
	    
		arq = new RandomAccessFile (arq_out, "rw");
		

		//Grava parte fixa
		arq.writeBytes(html_top);


		// grava tabela e lista de usuarios
		arq.writeBytes(html_tableheader);

		for (int i=0;i < players.getNplayers() -1; i++){

	        p = players.getLast();
	
	        if (p!= null)
				arq.writeBytes("<tr>\n" + 
							   "<td width=\"27%\">" + p.getVictorycount() + "</td>\n" + 
							   "<td width=\"73%\">" + p.getPlayername() + "</td>\n" + 
							   "</tr>\n");
		}

		p = players.getFirst();
		// para nao pegar o jogador de "paridade", que eh sempre null
		if (p!=null)
			
			arq.writeBytes("<tr>\n" + 
						   "<td width=\"27%\">" + p.getVictorycount() + "</td>\n" + 
						   "<td width=\"73%\">" + p.getPlayername() + "</td>\n" + 
						   "</tr>\n");
			
				
		// grava parte final do arquivo
		arq.writeBytes(html_bottom);	

		arq.close();
		} catch (Exception e) {

		System.out.println("Erro ao criar arquivo: " + arq_out +"\n " +  e.getMessage());

		}
	


	
	}
/**
 * Starts the application.
 * @param args an array of command-line arguments
 */
public static void main(java.lang.String[] args) {

	
	
  while(true){

	
	// Inicializa fila de jogadores
	PlayerQueue players = new PlayerQueue();

		
	System.out.println("Iniciando Campeonato.");
	
	// aloca todos os jogadores disponiveis dentro da faixa de ips determinada.
	summonPlayers(players,PlayerClient.MINIP,PlayerClient.MAXIP);

	if (players.getNplayers() > 1)
		// inicia campeonato, promovendo jogos entre todos os participantes
		startChampionship(players);


	// Ordena vetor de jogadores em ordem decrescente de classificacao
	players.sort();
	
 	
	// Grava html com classificacao
	gravaHtml(players,"stick.html");



	try{
		Thread.sleep(PERIODICIDADE);
	}
	catch (InterruptedException e){
		System.out.println("Thread interrompida.");
		}
	
  }
	
	
}
/**
 * Funcao inicia campeonato
 * Creation date: (3/24/00 2:54:57 AM)
 */
private static void startChampionship(PlayerQueue players) {
	
        // faz todas as rodadas
	for (int ordem=0; ordem <= 1; ordem++){
		
		//faz todas as rodadas
		for (int i=0; i < players.getNplayers() -1; i++){
		
			// verifica se ja esvaziou a fila de jogadores
			while(!players.queueEmpty()){

					Judge juiz;
					
					// Cria juiz, passando os dois jogadores
					if (ordem == 0)	
						juiz = new Judge(players.getFirst(),players.getLast());
					else
						juiz = new Judge(players.getLast(),players.getFirst());					

			}
			
			// rotaciona fila, para que todos os jogadores joguem com todos
			players.rollQueue();
		}

	}// end for ordem

	System.out.println("Campeonato terminado");	
		
	
}
/**
 * Aloca em vetor jogadores encontrados entre minIp e maxIp. 
 * Seta numero de jogadores.
 *
 *
 * Creation date: (3/22/00 10:56:13 PM)
 * @return mc600.gamemanager.PlayerServer[]
 * @param minIp int
 * @param maxIp int
 */
private static void summonPlayers(PlayerQueue p,int minIp, int maxIp) {
	

	//inicializa vetor de jogadores de modo que o numero seja sempre par
	PlayerClient players[] = new PlayerClient[(PlayerClient.MAXIP - PlayerClient.MINIP) + 
	    									  ((PlayerClient.MAXIP - PlayerClient.MINIP)%2!=0?1:0)];

	
	System.out.println("Verificando intervalo de portas: " + Player.MINIP + " a " + Player.MAXIP);
	
	
	// numero de jogadores validos encontrados
	int nplayers=0;

	for(int i=Player.MINIP;i<=Player.MAXIP;i++){


		try{

			// aloca jogador
			players[nplayers] = new PlayerClient(InetAddress.getByName ("localhost"), i);

			// derruba socket liberando para o proximo jogo
			players[nplayers].shutdown();

			nplayers++;
			
		}catch(Exception e) {}
		
		
	}


	// cria jogadores, garantindo que o numero sera par.
	// caso o numero original seja impar, sera criada uma entrada null no vetor
	p.createQueue(players,(nplayers) + (nplayers%2!=0?1:0) );
	
	System.out.println("Encontrado(s) " + nplayers + " jogador(es) valido(s).");	

}
}
