package mc600.gamemanager;

/**
 * Classe que implementa uma fila circular de jogadores, em um vetor.
 * 
 * Creation date: (3/25/00 8:08:59 PM)
 * @author: 
 */
class PlayerQueue {
	public mc600.gamemanager.PlayerClient[] players = null;

	private int pos = 0;	// ponteiro para o inicio da fila
	private int first = 0;  // cursor apontando para o proximo a sair
	private int last = 0;	// cursor apontando para o ultimo a sair
	public PlayerClient p1 = null;

	// flag indicando se p1 ja foi retirado da lista
	// isto ocorre devido ao fato de o P1 estar na verdade fora da fila,
	// dessa forma, nao importa o quanto ela gire, ele sempre sera o primeiro.
	private boolean gotP1 = false;
/**
 * Queue constructor comment.
 */
public PlayerQueue() {
	super();
}
/**
 * Insert the method's description here.
 * Creation date: (3/25/00 8:33:43 PM)
 * @param p mc600.gamemanager.PlayerClient[]
 * @param nplayers int
 */
public void createQueue(PlayerClient[] p, int nplayers) {
	

	// Cria vetor com tamanho exato para todos os jogadores menos o primeiro
	players = new PlayerClient[nplayers-1];


	// copia todos os valores.........
 	p1 =  p[0]; 

	for(int i=0; i < nplayers-1; i++)
		players[i] = p[i+1];	

		
	// seta posicao inicial da fila
	pos=0;
	first=0;
	last=nplayers-2;

	// flag indicando se p1 ja foi retirado da lista
	// isto ocorre devido ao fato de o P1 estar na verdade fora da fila,
	// dessa forma, nao importa o quanto ela gire, ele sempre sera o primeiro.
	gotP1 = false;
	
	}
/**
 * Insert the method's description here.
 * Creation date: (3/25/00 8:53:26 PM)
 * @return mc600.gamemanager.PlayerClient
 */
public PlayerClient getFirst() {

	int actual = first;

	if (!gotP1){
		// retorna p1, que eh sempre o primeiro
		gotP1 = true;
		return p1;
	}else{
		// como o primeiro esta fora da lista, soh atualiza indice a partir do segundo
		if (last != first)
			first = rollint(first,true,0,getNplayers()-2);
	}

	
	return players[actual];
}
/**
 * Insert the method's description here.
 * Creation date: (3/25/00 8:53:51 PM)
 * @return mc600.gamemanager.PlayerClient
 */
public PlayerClient getLast() {

	int actual = last;

	if (last != first)
	
		last = rollint(last,false,0,getNplayers()-2);

		
	return players[actual];
}
/**
 * Insert the method's description here.
 * Creation date: (3/25/00 8:24:05 PM)
 * @return int
 */
public int getNplayers() {
	return players.length+1;
}
/**
 * Insert the method's description here.
 * Creation date: (3/25/00 9:39:25 PM)
 * @return boolean
 */
public boolean queueEmpty() {
	return (last==first) && gotP1?true:false;
}
   /** This is a generic version of C.A.R Hoare's Quick Sort
	* algorithm.  This will handle arrays that are already
	* sorted, and arrays with duplicate keys.<BR>
	*
	* If you think of a one dimensional array as going from
	* the lowest index on the left to the highest index on the right
	* then the parameters to this function are lowest index or
	* left and highest index or right.  The first time you call
	* this function it will be with the parameters 0, a.length - 1.
	*
	* @param a       an integer array
	* @param lo0     left boundary of array partition
	* @param hi0     right boundary of array partition
	*/
   private void QuickSort(PlayerClient a[], int lo0, int hi0)
   {
	  int lo = lo0;
	  int hi = hi0;
	  PlayerClient mid;

	  if ( hi0 > lo0)
	  {

		 /* Arbitrarily establishing partition element as the midpoint of
		  * the array.
		  */
		 mid = a[ ( lo0 + hi0 ) / 2 ];

		 // loop through the array until indices cross
		 while( lo <= hi )
		 {
			/* find the first element that is greater than or equal to
			 * the partition element starting from the left Index.
			 */
	     while( ( lo < hi0 ) && ( (a[lo]!=null?a[lo].getVictorycount():0) < (mid!=null?mid.getVictorycount():0) ))
		 ++lo;

			/* find an element that is smaller than or equal to
			 * the partition element starting from the right Index.
			 */
	     while( ( hi > lo0 ) && ( (a[hi]!=null?a[hi].getVictorycount():0) > (mid!=null?mid.getVictorycount():0) ))
		 --hi;

			// if the indexes have not crossed, swap
			if( lo <= hi )
			{
			   swap(a, lo, hi);
			   ++lo;
			   --hi;
			}
		 }

		 /* If the right index has not reached the left side of array
		  * must now sort the left partition.
		  */
		 if( lo0 < hi )
			QuickSort( a, lo0, hi );

		 /* If the left index has not reached the right side of array
		  * must now sort the right partition.
		  */
		 if( lo < hi0 )
			QuickSort( a, lo, hi0 );

	  }
   }   
/**
 * Insert the method's description here.
 * Creation date: (3/25/00 8:26:06 PM)
 * @return int
 */
private int rollint(int i, boolean inc, int min, int max) {

	if (inc)
		i ++;
	else
		i--;

	if (i > max) 
		i = min;
	else if(i<min)
		i = max;

	
	return i;

}
/**
 * Insert the method's description here.
 * Creation date: (3/25/00 9:25:17 PM)
 */
public void rollQueue() {
	

	pos = rollint(pos,true,0,getNplayers()-2);
	first = pos;
	
	last = rollint(pos,false,0,getNplayers()-2);

	gotP1 = false;

		
	
	}
   public void sort()
   {

	// Cria vetor com tamanho exato para todos os jogadores
	PlayerClient p[] = new PlayerClient[getNplayers()];


	// copia todos os valores.........
 	p[0] = p1;

	for(int i=0; i < getNplayers()-1; i++)
		p[i+1] = players[i];	

	   
	  QuickSort(p, 0, p.length - 1);


	 createQueue(p,getNplayers());
   }   
private void swap(PlayerClient a[], int i, int j) {

	PlayerClient T;
	T = a[i];
	a[i] = a[j];
	a[j] = T;
}
}
